SystemOrganization addCategory: #'Glamour-Seaside-Core'!
SystemOrganization addCategory: #'Glamour-Seaside-Examples'!
SystemOrganization addCategory: #'Glamour-Seaside-Examples-Dev'!

!WATagBrush methodsFor: '*glamour-seaside' stamp: 'lr 11/6/2009 12:32'!
boxFlex: anObject
	self style: '-webkit-box-flex: ' , anObject asString.
	self style: '-moz-box-flex: ' , anObject asString.
	self style: 'box-flex: ' , anObject asString! !

WAPresenter subclass: #SGLTreePresenter
	instanceVariableNames: 'renderer model htmlId'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Seaside-Core'!

!SGLTreePresenter classSide methodsFor: 'instance creation' stamp: 'AndreiChis 7/27/2010 21:29'!
for: aModel with: aRenderer
	^ self basicNew initializeFor: aModel with: aRenderer ! !

!SGLTreePresenter methodsFor: 'selection' stamp: 'AndreiChis 7/20/2010 21:41'!
explicitSelection: anObject from: aPresentationModel
	"anObject is a node or a collection of nodes"
	aPresentationModel glamourPresentation isMultiple 
		ifTrue: [ 
			|nodesPaths|
			nodesPaths := OrderedCollection new.
			anObject isCollection 
				ifTrue: [ anObject do: [:each | nodesPaths add: each path ] ] 
				ifFalse: [nodesPaths add: anObject path]. 
			aPresentationModel selection: (MorphTreeMorphMultipleSelection new selectedNodePathList: nodesPaths ) ]
		ifFalse: [ aPresentationModel selection: (MorphTreeMorphSingleSelection new selectedNodePath: anObject path). ]! !

!SGLTreePresenter methodsFor: 'accessing' stamp: 'AndreiChis 7/27/2010 19:42'!
htmlId
	^ htmlId! !

!SGLTreePresenter methodsFor: 'accessing' stamp: 'AndreiChis 7/27/2010 19:42'!
htmlId: anObject
	htmlId := anObject! !

!SGLTreePresenter methodsFor: 'initialization' stamp: 'AndreiChis 7/27/2010 19:34'!
initializeFor: aModel with: aRenderer
	self initialize.
	model := aModel.
	renderer := aRenderer! !

!SGLTreePresenter methodsFor: 'actions' stamp: 'AndreiChis 7/27/2010 22:46'!
onClickActionForAppendButtonOn: html
	^ html jQuery ajax
		script: [ :s | 
			(model roots size > model amountShown) 
				ifTrue: [ "Load the required elements"
					s << (  (s jQuery id: self htmlId) children: '.glm-tree-root-ct' ) 
						append: [:h |
							self renderRootNodesBeginningWith: model amountShown+1 on: h ] ] .
			(model roots size > model amountShown) 
				ifFalse: [  "Disable the button for loading content"
					s << ( (s jQuery id: self htmlId) children: '.glm-tree-append-button'  ) attributeAt: 'disabled' put: true ].
			s << (JSStream new 
				nextPutAll: 'Glamour.tree.addRootIcon'; 
				arguments: (Array with: '#', self htmlId,  ' > .glm-tree-root-ct' with: 0 ) ) ] ! !

!SGLTreePresenter methodsFor: 'actions' stamp: 'AndreiChis 7/27/2010 22:57'!
onClickActionForNode: aNode withContent: aBlock on: html
	|rendered|
	rendered := aNode contents size > 0 and: [ aNode expanded ].
	
	^ html jQuery ajax script: [:s | 
		rendered "Render the node childrens or just update the model"
			ifTrue: [
				aNode expanded 
					ifTrue: [aNode expanded: false] 
					ifFalse: [aNode expanded: true] ] 
			ifFalse: [
				s << aBlock value.
				aNode expanded: true.
				rendered := true ].
		"Update the selection load the modifications"
		self updateSelectionWithNode: aNode on: s ] 
! !

!SGLTreePresenter methodsFor: 'actions' stamp: 'AndreiChis 7/27/2010 22:46'!
onClickActionForTag: aTag of: aNode on: html
	^ html jQuery ajax script: [:s | 
		aNode containerTree toggleFilteringByTag: aTag.
		s << ( html jQuery id: (self renderer uuidFor: aNode containerTree glamourPresentation ) )
			replaceWith: [ :h |
				self renderContentOn: h ] ] ! !

!SGLTreePresenter methodsFor: 'rendering' stamp: 'AndreiChis 7/27/2010 22:47'!
renderAppendButtonOn: html
	html submitButton
		onClick: (self onClickActionForAppendButtonOn: html);
		disabled: false;
		class: 'glm-tree-append-button';
         	with: 'Append'! !

!SGLTreePresenter methodsFor: 'rendering' stamp: 'AndreiChis 7/27/2010 22:27'!
renderContentOn: html
	self renderer widgetContainer
		class: 'list-presentation';
		id: self htmlId;
		with: [
			self renderInitialRootNodesOn: html.
			(model roots size > model amountShown) ifTrue: [ "Add a button for loading the remaining elements"
				self renderAppendButtonOn: html ] ]! !

!SGLTreePresenter methodsFor: 'rendering' stamp: 'AndreiChis 7/27/2010 22:31'!
renderInitialRootNodesOn: html
	|listId|
	listId := html nextId.
	html unorderedList   
		class: 'glm-tree-root-ct';
		id: listId;
		script:  (JSStream new 
			nextPutAll: 'Glamour.tree.bindEvents'; 
			arguments: (Array with: listId with: 0 ) );
		with: [ self renderRootNodesBeginningWith: 1 on: html ]! !

!SGLTreePresenter methodsFor: 'rendering' stamp: 'AndreiChis 7/27/2010 22:02'!
renderNode: aNode fromLevel: level on: html
	|childrens|
	aNode htmlId: html nextId.
	childrens := aNode contents.
	html listItem  
		id: aNode htmlId;  
		class: 'glm-tree-node';
		class: 'glm-tree-leaf' if: childrens size == 0;
		class: 'glm-tree-open' if: (childrens size > 0 and: [aNode expanded]);
		class: 'glm-tree-closed' if: (childrens size > 0 and: [aNode expanded not]);
		with: [
			self renderNodeTitleFor: aNode 
				withContent: [
					(html jQuery id: aNode htmlId) append: [:h | 
						self renderNodes: childrens asListFromLevel: level+1 on: h ] ]
				on: html.
			(childrens size > 0 and: [ aNode expanded] ) ifTrue: [ 
				self renderNodes: childrens asListFromLevel: level+1 on: html ] ]! !

!SGLTreePresenter methodsFor: 'rendering' stamp: 'AndreiChis 7/27/2010 22:54'!
renderNodeTitleFor: aNode withContent: aBlock on: html
	html div
		class: 'glm-tree-node-el';
		onClick: (self onClickActionForNode: aNode withContent: aBlock on: html);
		with: [ 
			html span with: [
				html span
					with: aNode displayText. 
				self renderTagsOf: aNode on: html ] ]! !

!SGLTreePresenter methodsFor: 'rendering' stamp: 'AndreiChis 7/27/2010 22:31'!
renderNodes: nodes asListFromLevel: level on: html
	html unorderedList 
		id: html nextId;
		script: (JSStream new 
					nextPutAll: 'Glamour.tree.bindEvents'; 
					arguments: (Array with: html lastId with: level ) );
		class: 'glm-tree-node-ct';
		with: [ nodes do: [:each | 
			self renderNode: each fromLevel: level on: html ] ]! !

!SGLTreePresenter methodsFor: 'rendering' stamp: 'AndreiChis 7/27/2010 21:53'!
renderRootNodesBeginningWith: startIndex on: html
	"Render the first 'amountToShow' elements starting from the one with the index 'startIndex'"
	
	|endIndex nodes|
	nodes := model roots.
	(startIndex == 1 and: [model amountShown ~= 0 ] ) 
		ifTrue: [ endIndex  := model amountShown min: model roots size ] 
		ifFalse: [ endIndex := startIndex+model amountToShow-1 ].
	(startIndex to: endIndex) do: [ :each |   
			self renderNode: (nodes at: each)  fromLevel: 0 on: html ].
	(startIndex == 1 and: [model amountShown ~= 0 ] ) 
		ifTrue: [
			 model amountShown: (model amountShown max: endIndex) ]  
		ifFalse: [
			model amountShown: model amountToShow + model amountShown ] ! !

!SGLTreePresenter methodsFor: 'rendering' stamp: 'AndreiChis 7/27/2010 22:47'!
renderTag: aTag withFilter: aFilter for: aNode on: html
	html div
		class: 'glm-tree-tag ui-corner-top ui-corner-bottom';
		class: 'glm-tree-tag-selected' if: ( aNode containerTree tagsToFilterBy includes: aTag );
		onClick: (self onClickActionForTag: aTag of: aNode on: html);
		onClick: JQEvent new stopPropagation, JQEvent new preventDefault;
		with: aTag asString ! !

!SGLTreePresenter methodsFor: 'rendering' stamp: 'AndreiChis 7/27/2010 22:40'!
renderTagsOf: aNode on: html
	| tags tagsFilter |
	tags:= aNode containerTree glamourPresentation tagsFor: aNode item to: #show.
	tagsFilter := aNode containerTree glamourPresentation tagsFor: aNode item to: #filter.
	html div
		class: 'glm-tree-tags';
		with: [
			tags withIndexDo:[ :each :index | 
				self renderTag: each withFilter: (tagsFilter at: index ifAbsentPut:[ each ] ) for: aNode on: html ] ]! !

!SGLTreePresenter methodsFor: 'accessing' stamp: 'AndreiChis 7/27/2010 21:35'!
renderer 
	^ renderer! !

!SGLTreePresenter methodsFor: 'updating' stamp: 'AndreiChis 7/27/2010 23:01'!
updateSelectedNodesFrom: aPresentationModel
	self renderer scriptFor: aPresentationModel glamourPresentation add: (
		JSStream new 
			nextPutAll:  'Glamour.tree.deselectAll'; 
			argument: self htmlId).
	aPresentationModel selection selectedNodes do: [:each | 
		self renderer scriptFor: aPresentationModel glamourPresentation add: (
			JSStream new 
				nextPutAll:  'Glamour.tree.selectNode'; 
				argument: each htmlId ) ]! !

!SGLTreePresenter methodsFor: 'updating' stamp: 'AndreiChis 7/27/2010 23:01'!
updateSelectionWithNode: aNode on: aScript
	self explicitSelection: aNode from: aNode containerTree.
	self updateSelectedNodesFrom: aNode containerTree.
	self renderer updateScript: aScript! !

WAFileLibrary subclass: #SGLFileLibrary
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Seaside-Core'!

!SGLFileLibrary methodsFor: 'uploaded' stamp: ''!
arrowsPng
	^ #(137 80 78 71 13 10 26 10 0 0 0 13 73 72 68 82 0 0 0 39 0 0 0 19 8 3 0 0 0 36 150 228 188 0 0 0 4 103 65 77 65 0 0 177 142 124 251 81 147 0 0 0 32 99 72 82 77 0 0 135 15 0 0 140 15 0 0 253 82 0 0 129 64 0 0 125 121 0 0 233 139 0 0 60 229 0 0 25 204 115 60 133 119 0 0 10 57 105 67 67 80 80 104 111 116 111 115 104 111 112 32 73 67 67 32 112 114 111 102 105 108 101 0 0 72 199 157 150 119 84 84 215 22 135 207 189 119 122 161 205 48 2 82 134 222 187 192 0 210 123 147 94 69 97 152 25 96 40 3 14 51 52 177 33 162 2 17 69 68 154 34 72 80 196 128 209 80 36 86 68 177 16 20 84 176 7 36 8 40 49 24 69 84 44 111 70 214 139 174 172 188 247 242 242 251 227 172 111 237 179 247 185 251 236 189 207 90 23 0 146 167 47 151 151 6 75 1 144 202 19 240 131 60 156 233 17 145 81 116 236 0 128 1 30 96 128 41 0 76 86 70 186 95 176 123 8 16 201 203 205 133 158 33 114 2 95 4 1 240 122 88 188 2 112 211 208 51 128 78 7 255 159 164 89 233 124 129 232 152 0 17 155 179 57 25 44 17 23 136 56 37 75 144 46 182 207 138 152 26 151 44 102 24 37 102 190 40 65 17 203 137 57 97 145 13 62 251 44 178 163 152 217 169 60 182 136 197 57 167 179 83 217 98 238 21 241 182 76 33 71 196 136 175 136 11 51 185 156 44 17 223 18 177 70 138 48 149 43 226 55 226 216 84 14 51 3 0 20 73 108 23 112 88 137 34 54 17 49 137 31 18 228 34 226 229 0 224 72 9 95 113 220 87 44 224 100 11 196 151 114 73 75 207 225 115 19 18 5 116 29 150 46 221 212 218 154 65 247 228 100 165 112 4 2 195 0 38 43 153 201 103 211 93 210 82 211 153 188 28 0 22 239 252 89 50 226 218 210 69 69 182 52 181 182 180 52 52 51 50 253 170 80 255 117 243 111 74 220 219 69 122 25 248 185 103 16 173 255 139 237 175 252 210 26 0 96 204 137 106 179 243 139 45 174 10 128 206 45 0 200 221 251 98 211 56 0 128 164 168 111 29 215 191 186 15 77 60 47 137 2 65 186 141 177 113 86 86 150 17 151 195 50 18 23 244 15 253 79 135 191 161 175 190 103 36 62 238 143 242 208 93 57 241 76 97 138 128 46 174 27 43 45 37 77 200 167 103 164 51 89 28 186 225 159 135 248 31 7 254 117 30 6 65 156 120 14 159 195 19 69 132 137 166 140 203 75 16 181 155 199 230 10 184 105 60 58 151 247 159 154 248 15 195 254 164 197 185 22 137 210 248 17 80 99 140 128 212 117 42 64 126 237 7 40 10 17 32 209 251 197 93 255 163 111 190 248 48 32 126 121 225 42 147 139 115 255 239 55 253 103 193 165 226 37 131 155 240 57 206 37 40 132 206 18 242 51 23 247 196 207 18 160 1 1 72 2 42 144 7 202 64 29 232 0 67 96 6 172 128 45 112 4 110 192 27 248 131 16 16 9 86 3 22 72 4 169 128 15 178 64 30 216 4 10 65 49 216 9 246 128 106 80 7 26 65 51 104 5 199 65 39 56 5 206 131 75 224 26 184 1 110 131 251 96 20 76 128 103 96 22 188 6 11 16 4 97 33 50 68 129 228 33 21 72 19 210 135 204 32 6 100 15 185 65 190 80 16 20 9 197 66 9 16 15 18 66 121 208 102 168 24 42 131 170 161 122 168 25 250 30 58 9 157 135 174 64 131 208 93 104 12 154 134 126 135 222 193 8 76 130 169 176 18 172 5 27 195 12 216 9 246 129 67 224 85 112 2 188 6 206 133 11 224 29 112 37 220 0 31 133 59 224 243 240 53 248 54 60 10 63 131 231 16 128 16 17 26 162 138 24 34 12 196 5 241 71 162 144 120 132 143 172 71 138 144 10 164 1 105 69 186 145 62 228 38 50 138 204 32 111 81 24 20 5 69 71 25 162 108 81 158 168 80 20 11 181 6 181 30 85 130 170 70 29 70 117 160 122 81 55 81 99 168 89 212 71 52 25 173 136 214 71 219 160 189 208 17 232 4 116 22 186 16 93 129 110 66 183 163 47 162 111 163 39 208 175 49 24 12 13 163 141 177 194 120 98 34 49 73 152 181 152 18 204 62 76 27 230 28 102 16 51 142 153 195 98 177 242 88 125 172 29 214 31 203 196 10 176 133 216 42 236 81 236 89 236 16 118 2 251 6 71 196 169 224 204 112 238 184 40 28 15 151 143 171 192 29 193 157 193 13 225 38 113 11 120 41 188 38 222 6 239 143 103 227 115 240 165 248 70 124 55 254 58 126 2 191 64 144 38 104 19 236 8 33 132 36 194 38 66 37 161 149 112 145 240 128 240 146 72 36 170 17 173 137 129 68 46 113 35 177 146 120 140 120 153 56 70 124 75 146 33 233 145 92 72 209 36 33 105 7 233 16 233 28 233 46 233 37 153 76 214 34 59 146 163 200 2 242 14 114 51 249 2 249 17 249 141 4 69 194 72 194 75 130 45 177 65 162 70 162 67 98 72 226 185 36 94 82 83 210 73 114 181 100 174 100 133 228 9 201 235 146 51 82 120 41 45 41 23 41 166 212 122 169 26 169 147 82 35 82 115 210 20 105 83 105 127 233 84 233 18 233 35 210 87 164 167 100 176 50 90 50 110 50 108 153 2 153 131 50 23 100 198 41 8 69 157 226 66 97 81 54 83 26 41 23 41 19 84 12 85 155 234 69 77 162 22 83 191 163 14 80 103 101 101 100 151 201 134 201 102 203 214 200 158 150 29 165 33 52 45 154 23 45 133 86 74 59 78 27 166 189 91 162 180 196 105 9 103 201 246 37 173 75 134 150 204 203 45 149 115 148 227 200 21 201 181 201 221 150 123 39 79 151 119 147 79 150 223 37 223 41 255 80 1 165 160 167 16 168 144 165 176 95 225 162 194 204 82 234 82 219 165 172 165 69 75 143 47 189 167 8 43 234 41 6 41 174 85 60 168 216 175 56 167 164 172 228 161 148 174 84 165 116 65 105 70 153 166 236 168 156 164 92 174 124 70 121 90 133 162 98 175 194 85 41 87 57 171 242 148 46 75 119 162 167 208 43 233 189 244 89 85 69 85 79 85 161 106 189 234 128 234 130 154 182 90 168 90 190 90 155 218 67 117 130 58 67 61 94 189 92 189 71 125 86 67 69 195 79 35 79 163 69 227 158 38 94 147 161 153 168 185 87 179 79 115 94 75 91 43 92 107 171 86 167 214 148 182 156 182 151 118 174 118 139 246 3 29 178 142 131 206 26 157 6 157 91 186 24 93 134 110 178 238 62 221 27 122 176 158 133 94 162 94 141 222 117 125 88 223 82 159 171 191 79 127 208 0 109 96 109 192 51 104 48 24 49 36 25 58 25 102 26 182 24 142 25 209 140 124 141 242 141 58 141 158 27 107 24 71 25 239 50 238 51 254 104 98 97 146 98 210 104 114 223 84 198 212 219 52 223 180 219 244 119 51 61 51 150 89 141 217 45 115 178 185 187 249 6 243 46 243 23 203 244 151 113 150 237 95 118 199 130 98 225 103 177 213 162 199 226 131 165 149 37 223 178 213 114 218 74 195 42 214 170 214 106 132 65 101 4 48 74 24 151 173 209 214 206 214 27 172 79 89 191 181 177 180 17 216 28 183 249 205 214 208 54 217 246 136 237 212 114 237 229 156 229 141 203 199 237 212 236 152 118 245 118 163 246 116 251 88 251 3 246 163 14 170 14 76 135 6 135 199 142 234 142 108 199 38 199 73 39 93 167 36 167 163 78 207 157 77 156 249 206 237 206 243 46 54 46 235 92 206 185 34 174 30 174 69 174 3 110 50 110 161 110 213 110 143 220 213 220 19 220 91 220 103 61 44 60 214 122 156 243 68 123 250 120 238 242 28 241 82 242 98 121 53 123 205 122 91 121 175 243 238 245 33 249 4 251 84 251 60 246 213 243 229 251 118 251 193 126 222 126 187 253 30 172 208 92 193 91 209 233 15 252 189 252 119 251 63 12 208 14 88 19 240 99 32 38 48 32 176 38 240 73 144 105 80 94 80 95 48 37 56 38 248 72 240 235 16 231 144 210 144 251 161 58 161 194 208 158 48 201 176 232 176 230 176 249 112 215 240 178 240 209 8 227 136 117 17 215 34 21 34 185 145 93 81 216 168 176 168 166 168 185 149 110 43 247 172 156 136 182 136 46 140 30 94 165 189 42 123 213 149 213 10 171 83 86 159 142 145 140 97 198 156 136 69 199 134 199 30 137 125 207 244 103 54 48 231 226 188 226 106 227 102 89 46 172 189 172 103 108 71 118 57 123 154 99 199 41 227 76 198 219 197 151 197 79 37 216 37 236 78 152 78 116 72 172 72 156 225 186 112 171 185 47 146 60 147 234 146 230 147 253 147 15 37 127 74 9 79 105 75 197 165 198 166 158 228 201 240 146 121 189 105 202 105 217 105 131 233 250 233 133 233 163 107 108 214 236 89 51 203 247 225 55 101 64 25 171 50 186 4 84 209 207 84 191 80 71 184 69 56 150 105 159 89 147 249 38 43 44 235 68 182 116 54 47 187 63 71 47 103 123 206 100 174 123 238 183 107 81 107 89 107 123 242 84 243 54 229 141 173 115 90 87 191 30 90 31 183 190 103 131 250 134 130 13 19 27 61 54 30 222 68 216 148 188 233 167 124 147 252 178 252 87 155 195 55 119 23 40 21 108 44 24 223 226 177 165 165 80 162 144 95 56 178 213 118 107 221 54 212 54 238 182 129 237 230 219 171 182 127 44 98 23 93 45 54 41 174 40 126 95 194 42 185 250 141 233 55 149 223 124 218 17 191 99 160 212 178 116 255 78 204 78 222 206 225 93 14 187 14 151 73 151 229 150 141 239 246 219 221 81 78 47 47 42 127 181 39 102 207 149 138 101 21 117 123 9 123 133 123 71 43 125 43 187 170 52 170 118 86 189 175 78 172 190 93 227 92 211 86 171 88 187 189 118 126 31 123 223 208 126 199 253 173 117 74 117 197 117 239 14 112 15 220 169 247 168 239 104 208 106 168 56 136 57 152 121 240 73 99 88 99 223 183 140 111 155 155 20 154 138 155 62 28 226 29 26 61 28 116 184 183 217 170 185 249 136 226 145 210 22 184 69 216 50 125 52 250 232 141 239 92 191 235 106 53 108 173 111 163 181 21 31 3 199 132 199 158 126 31 251 253 240 113 159 227 61 39 24 39 90 127 208 252 161 182 157 210 94 212 1 117 228 116 204 118 38 118 142 118 69 118 13 158 244 62 217 211 109 219 221 254 163 209 143 135 78 169 158 170 57 45 123 186 244 12 225 76 193 153 79 103 115 207 206 157 75 63 55 115 62 225 252 120 79 76 207 253 11 17 23 110 245 6 246 14 92 244 185 120 249 146 251 165 11 125 78 125 103 47 219 93 62 117 197 230 202 201 171 140 171 157 215 44 175 117 244 91 244 183 255 100 241 83 251 128 229 64 199 117 171 235 93 55 172 111 116 15 46 31 60 51 228 48 116 254 166 235 205 75 183 188 110 93 187 189 226 246 224 112 232 240 157 145 232 145 209 59 236 59 83 119 83 238 190 184 151 121 111 225 254 198 7 232 7 69 15 165 30 86 60 82 124 212 240 179 238 207 109 163 150 163 167 199 92 199 250 31 7 63 190 63 206 26 127 246 75 198 47 239 39 10 158 144 159 84 76 170 76 54 79 153 77 157 154 118 159 190 241 116 229 211 137 103 233 207 22 102 10 127 149 254 181 246 185 206 243 31 126 115 252 173 127 54 98 118 226 5 255 197 167 223 75 94 202 191 60 244 106 217 171 158 185 128 185 71 175 83 95 47 204 23 189 145 127 115 248 45 227 109 223 187 240 119 147 11 89 239 177 239 43 63 232 126 232 254 232 243 241 193 167 212 79 159 254 5 3 152 243 252 186 196 232 211 0 0 3 0 80 76 84 69 0 0 0 37 37 37 38 38 38 89 89 89 132 132 132 149 149 149 150 150 150 159 159 159 164 164 164 165 165 165 167 167 167 230 230 230 233 233 233 234 234 234 251 251 251 252 252 252 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 110 174 208 68 0 0 1 0 116 82 78 83 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 0 83 247 7 37 0 0 0 9 112 72 89 115 0 0 11 18 0 0 11 18 1 210 221 126 252 0 0 0 25 116 69 88 116 83 111 102 116 119 97 114 101 0 80 97 105 110 116 46 78 69 84 32 118 51 46 53 46 53 73 138 252 224 0 0 0 99 73 68 65 84 40 83 197 210 75 14 128 32 12 4 80 24 252 161 34 247 63 45 178 192 104 237 36 116 71 151 228 209 76 41 174 216 202 217 88 25 236 34 141 137 247 180 229 139 59 129 240 218 165 85 65 4 210 239 74 243 15 34 48 151 243 49 9 88 25 239 183 72 230 81 75 231 59 117 62 113 175 205 187 177 121 191 240 121 151 222 154 7 239 183 23 207 252 255 110 230 158 181 143 132 192 216 14 0 0 0 0 73 69 78 68 174 66 96 130) asByteArray! !

!SGLFileLibrary methodsFor: 'uploaded' stamp: 'AndreiChis 7/27/2010 22:31'!
glamourSeasideJs
	^ '	var Glamour = {};
	
	Glamour.resize = function() {
		$("body > .sgl-table, body > .finder-container").each(function() {
			$(this).height($(window).height() - 20);
		});
	};

	Glamour.disableClickEvent = function(id) {
		document.getElementById(id).onclick = null;
	};

	Glamour.tree = {};
	
	Glamour.tree.deselectAll = function(treeId) {
		$("#"+treeId + " .glm-tree-node-selected").removeClass("glm-tree-node-selected");
	};
	
	Glamour.tree.selectNode = function(nodeId) {
		$("#"+nodeId).addClass("glm-tree-node-selected");
	}; 
	
	Glamour.tree.bindEvents = function(listId, level) {
		var padding = "";
		
		// Create a padding
		for (var index = 0; index < level; index++) {
			padding += "<ins class=\"glm-tree-icon-padding\">&nbsp</ins>";
		}
		
		// Bind the events
		$("#"+listId+" > .glm-tree-node > .glm-tree-node-el").bind("click", function(){
			var parent = $(this).parent();
			
			Glamour.tree.collapsible(parent);
			// Glamour.tree.selection(parent);
		}).find(":first").before("<span>"+padding+"</span>").before(Glamour.tree.icon) ; 
	}
	
	Glamour.tree.addRootIcon = function(listSelector) {
		$(listSelector+" > .glm-tree-node > .glm-tree-node-el").find(":first").before(function() {
			if ( $(this).parent().children("ins").size() == 0 && $(this).parent().parent().hasClass("glm-tree-leaf") == false )
				return "<span></span>" + Glamour.tree.icon();
		}) ; 
	}
	
	Glamour.tree.icon = function() {
		
		if (  $(this).parent().parent().hasClass("glm-tree-leaf") == false ) {
			return  "<ins class=\"glm-tree-icon\">&nbsp;</ins>";
		}
	}
	
	Glamour.tree.selection = function(element) {
		element.addClass("glm-tree-node-selected");
		if (typeof Glamour.tree.selectedId !!== "undefined" && Glamour.tree.selectedId !!== element.attr("id") ) {
			$("#"+Glamour.tree.selectedId).removeClass("glm-tree-node-selected");
		} 
		
		Glamour.tree.selectedId = element.attr("id");
	}
	
	Glamour.tree.collapsible = function(element) {
		if ( element.hasClass("glm-tree-open") ) {
			element.removeClass("glm-tree-open");
			element.addClass("glm-tree-closed");
			element.children(".glm-tree-node-ct").hide();
		} else if ( element.hasClass("glm-tree-closed")  ) {
			element.removeClass("glm-tree-closed");
			element.addClass("glm-tree-open");
			element.children(".glm-tree-node-ct").show();
		}
	};

$(Glamour.resize);
$(window).resize(Glamour.resize);'! !

!SGLFileLibrary methodsFor: 'uploaded' stamp: 'AndreiChis 7/18/2010 00:14'!
styleCss
	^ '/* html */
* {margin:0; padding:0;}

html, body {
	overflow: hidden;
	height: 100%;
}

body {
	font-size: 0.8em;
	margin: 8px;
}

body, table, td, th, input, select, textarea, button {
	font-family: Verdana, Arial, sans-serif;
}
input, select, textarea {
	outline: 0;
	margin: 0;
	padding: 0;
	width: 100%;
	height: 100%;
	border: none;
	outline: none;
	display: block;
	background-color: transparent;
}

/* layout */

.finder-container {
	overflow-x: auto;
	overflow-y: hidden;
	height: 100%;
}

div.finder {
	width: 100%;
	height: 98%;
	overflow-x: auto;
	position: relative;
	display: -webkit-box; display: -moz-box; display: box;
	-webkit-box-align: stretch; -moz-box-align: stretch; box-align: stretch;
	-webkit-box-orient: horizontal; -moz-box-orient: horizontal; box-orient: horizontal;
}
div.finder > div.finder-pane {
	min-width: 150px;
	max-width: 500px;
	height: 100%;
	width: 100%;
	display: -webkit-box; display: -moz-box; display: box;
	-webkit-box-align: stretch; -moz-box-align: stretch; box-align: stretch;
	-webkit-box-orient: horizontal; -moz-box-orient: horizontal; box-orient: horizontal;
}

div.finder-pane > * {
	width: auto;
	height: 100%;
	-webkit-box-flex: 1; -moz-box-flex: 1; box-flex: 1;
}

/* jquery ui */
.ui-tabs {
	position: relative;
	display: -webkit-box; display: -moz-box; display: box;
	-webkit-box-align: stretch; -moz-box-align: stretch; box-align: stretch;
	-webkit-box-orient: vertical; -moz-box-orient: vertical; box-orient: vertical;
}
.ui-tabs > .ui-tabs-nav {
	-webkit-box-flex: 0; -moz-box-flex: 0; box-flex: 0;
}
.ui-tabs > .ui-tabs-panel {
	padding: 0;
	-webkit-box-flex: 1; -moz-box-flex: 1; box-flex: 1;
	display: -webkit-box; display: -moz-box; display: box;
	-webkit-box-align: stretch; -moz-box-align: stretch; box-align: stretch; 
	/* -webkit-box-orient: vertical; -moz-box-orient: vertical; box-orient: vertical; */
}

.ui-tabs-panel > * {
	-webkit-box-flex: 1; -moz-box-flex: 1; box-flex: 1;
}

/* presentations */

.empty-presentation{
	min-height:50px;
}

.presentation-container {
	
}

.presentation-container > * {
	-webkit-box-flex: 1; -moz-box-flex: 1; box-flex: 1;
}

.list-presentation {
	display: -webkit-box; display: -moz-box; display: box;
	-webkit-box-align: stretch; -moz-box-align: stretch; box-align: stretch;
	-webkit-box-orient: vertical; -moz-box-orient: vertical; box-orient: vertical;
	-webkit-box-flex: 1; -moz-box-flex: 1; box-flex: 1;
}

.list-presentation > ul {
	-webkit-box-flex: 1; -moz-box-flex: 1; box-flex: 1;
	overflow: auto;
	min-height: 100px;
	min-width: 100px;
}

.list-presentation > ul > li {
	-webkit-box-flex: 1; -moz-box-flex: 1; box-flex: 1;
}

.list-presentation > input {
	height: 25px;
	background-color: #EBEBEB;
	-webkit-box-flex: 0; -moz-box-flex: 0; box-flex: 0;
}

.ui-accordion-content > * {
	-webkit-box-flex: 1; -moz-box-flex: 1; box-flex: 1;
}


/* presentations with title */

.presentation-with-title, .presentation-content {
	position: relative;
	display: -webkit-box; display: -moz-box; display: box;
	-webkit-box-align: stretch; -moz-box-align: stretch; box-align: stretch;
	-webkit-box-orient: vertical; -moz-box-orient: vertical; box-orient: vertical;
}

.presentation-with-title {
	padding: 0.2em;
}

.presentation-title {
	display: block;
	border: 1px solid #4297D7;
	background-color: #E1E1E1;
	padding: 0.2em 0.2em 0;
}

.presentation-title {
	-webkit-box-flex: 0; -moz-box-flex: 0; box-flex: 0;
}

.presentation-title li {
	border-bottom:0 none !!important;
	float:left;
	list-style:none outside none;
	margin:0 0.2em 1px 0;
	padding:0;
	position:relative;
	top:1px;
	white-space:nowrap;
}

.presentation-title li span {
	float: left;
	padding: 0.5em 1em;
}

.presentation-content {
	padding: 0;
	-webkit-box-flex: 1; -moz-box-flex: 1; box-flex: 1;
	background: none repeat scroll 0 0 transparent;
	border-width: 0;
}

.presentation-content > div {
	-webkit-box-flex: 1; -moz-box-flex: 1; box-flex: 1;
}


/* composite arrangements */
.stacked-arrangement, .tabbed-arrangement, .accordion-arrangement {
	position: relative;
	width: 100%;
	padding: 0;
}

.stacked-arrangement, .accordion-arrangement {
	position: relative;
	display: -webkit-box; display: -moz-box; display: box;
	-webkit-box-align: stretch; -moz-box-align: stretch; box-align: stretch;
	-webkit-box-orient: vertical; -moz-box-orient: vertical; box-orient: vertical;
}

.stacked-arrangement > *{
	-webkit-box-flex: 1; -moz-box-flex: 1; box-flex: 1;
}

.accordion-arrangement > .ui-accordion-content {
	-webkit-box-flex: 1; -moz-box-flex: 1; box-flex: 1;
	display: -webkit-box; display: -moz-box; display: box;
}

/* List/tree presentation */

.glm-tree-root-ct {
	cursor: pointer;
}

.glm-tree-root-ct > .glm-tree-node {
	margin-top: 1px;
}

.glm-tree-node-selected > .glm-tree-node-el{
	background-color: #E3E0D0;
}

.glm-tree-icon-padding {
	background-repeat:no-repeat;
	border:0 none;
	height:18px;
	margin:0;
	padding:0;
	vertical-align:top;
	width:16px;
	display:inline-block;
	text-decoration:none;
}

.glm-tree-root-ct .glm-tree-icon {
	display:inline-block;
	height:18px;
	margin:0;
	padding:0;
	text-decoration:none;
	width:14px;
}

.glm-tree-node-el > .glm-tree-icon  {
	background-image:url("arrows.png");
	background-repeat:no-repeat;
}

.glm-tree-closed > .glm-tree-node-el > .glm-tree-icon {
	background-position: -4px 0;
}

.glm-tree-open > .glm-tree-node-el > .glm-tree-icon {
	background-position: -22px 0;
}

/* actions */
.glm-ac-container {
	float: right;
	cursor: pointer;
	min-height: 28px;
}

.ui-state-default > .glm-ac-container {
	display: none;
}

.ui-tabs-selected > .glm-ac-container {
	display: block;
}

.glm-ac-container > img {
	margin-right: 2px;
}

.ui-accordion .ui-state-active a {
	display: inline;
	position: absolute;
	margin-top: -15px;
	top: 50%;
}

/* Actions */
.glm-tree-tags, .glm-tree-tag {
	display: inline;
}

.glm-tree-tags {
	padding-left: 2px;
}

.glm-tree-tag {
	margin-left: 3px;
	background-color: #808080;
}

.glm-tree-tag-selected {
	background-color: #BFBFBF;
}

/* table layout */
.sgl-table {
	width: 100%;	
	position: relative;
}

.sgl-table-hbox, 
.sgl-table-hbox > *,
.sgl-table-vbox > * {
	position: relative;
	display: -webkit-box; display: -moz-box; display: box;
	-webkit-box-align: stretch; -moz-box-align: stretch; box-align: stretch;
	-webkit-box-orient: horizontal; -moz-box-orient: horizontal; box-orient: horizontal;
}

.sgl-table-hbox > *, 
.sgl-table-hbox > * > *,
.sgl-table-vbox > * > * {
	-webkit-box-flex: 1; -moz-box-flex: 1; box-flex: 1;
}

.sgl-table-vbox {
	position: relative;
	display: -webkit-box; display: -moz-box; display: box;
	-webkit-box-orient: vertical; -moz-box-orient: vertical; box-orient: vertical;
	-webkit-box-align: stretch; -moz-box-align: stretch; box-align: stretch;
}

.sgl-table-vbox > * {
	-webkit-box-flex: 1; -moz-box-flex: 1; box-flex: 1;
}

.sgl-table-split {
	width: 5px; height: 5px;
	-webkit-box-flex: 0; -moz-box-flex: 0; box-flex: 0;
}

/* magritte layout */
div.magritte { width: 100%; }
div.magritte th { width: 150px; }
div.magritte textarea { height: 250px; }
div.magritte table { width: 100%; padding: .3em 1em 0 .4em; }
div.magritte input, div.magritte textarea { width: 100%; border: 1px solid #d3d3d3; background: #e6e6e6; }
div.magritte .buttons { text-align: right; border-width: 1px 0 0 0; margin: .5em 0 0 0; padding: .3em 1em .5em .4em; }
div.magritte .submit { display: inline; margin: .5em .4em .5em 0; cursor: pointer; padding: .2em .6em .3em .6em; line-height: 1.4em; width: auto; overflow: visible; border: 1px solid #d3d3d3; background: #e6e6e6 url(/seaside/files/JQUiSmoothnessTheme/uibgglass75e6e6e61x400.png) 50% 50% repeat-x; font-weight: normal; color: #555555; outline: none; }'! !

WAComponent subclass: #SGLComponent
	instanceVariableNames: 'presentation'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Seaside-Core'!

SGLComponent subclass: #SGLAccumulator
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Seaside-Examples-Dev'!

!SGLAccumulator classSide methodsFor: 'as yet unclassified' stamp: 'AndreiChis 7/1/2010 19:38'!
initialize
	self registerAsApplication: 'glamour/accumulator/composedAccumulator'! !

!SGLAccumulator methodsFor: 'as yet unclassified' stamp: 'AndreiChis 7/16/2010 21:08'!
browser
	| browser acc |
	browser := GLMTabulator new.
	acc := GLMAccumulator new.
	acc show: [:a | 
		a title: [:x | x asString].
		a list title: 'List'; display: [:x |1 to: x ]; showOnly: 10.
		a text title: 'Text'; display: [:x | 'This is an editor on ', x printString ].
		].
	browser column: [:c | c row: #one span: 4; row: #two]; column: #three; column: #four.
	browser transmit to: #one; andShow: [:a | 
		a list display: [:x | x to: 10 * x]; showOnly: 10].
	browser transmit from: #one; to: #two; andShow: [:a |
		a text display: [:x | 'You have selected ', x printString, '. Double cick to open to the right']].
	browser transmit from: #one; to: #three; andShowIfNone: [:a |
		a custom: acc ].
	
	browser transmit from: #three; to: #four; andShow: [ :a |
		a list display: [:x| 1 to: x]	].

	^ browser
	! !

!SGLAccumulator methodsFor: 'as yet unclassified' stamp: 'AndreiChis 6/15/2010 00:01'!
model
	^ 42! !

SGLComponent subclass: #SGLAccumulatorWithActions
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Seaside-Examples-Dev'!

SGLComponent subclass: #SGLAllowNil
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Seaside-Examples'!

!SGLAllowNil classSide methodsFor: 'initialization' stamp: 'AndreiChis 5/31/2010 00:02'!
initialize
	self registerAsApplication: 'glamour/basicExamples/allowNill'! !

!SGLAllowNil methodsFor: 'as yet unclassified' stamp: 'AndreiChis 5/31/2010 00:03'!
browser
	^GLMBasicExamples new allowNil ! !

!SGLAllowNil methodsFor: 'as yet unclassified' stamp: 'AndreiChis 5/31/2010 00:03'!
model
	^ 42! !

SGLComponent subclass: #SGLCodeBrowser
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Seaside-Examples'!

!SGLCodeBrowser classSide methodsFor: 'initialization' stamp: 'lr 8/25/2009 17:23'!
initialize
	self registerAsApplication: 'glamour/code'! !

!SGLCodeBrowser methodsFor: 'accessing' stamp: 'AndreiChis 5/31/2010 14:07'!
browser
	| browser |
	browser := GLMTabulator new.   

	browser row: [ :row | row column: #classes; column: #selectors ].
	browser row: #source.

	browser showOn: #classes; using: [
		browser tree
			title: 'Tree';
			children: [ :class | class subclasses ].
		browser mondrian
			title: 'Mondrian';
			painting: [ :view :class |
				view nodeShape size: 10. 
				view nodes: class withAllSubclasses.
				view edgesFrom: #superclass. 
				view treeLayout ] ].
	browser showOn: #selectors; from: #classes; using: [
		browser list 
			display: [ :class | class selectors asSortedCollection ] ].

	browser showOn: #source; from: #classes; from: #selectors; using: [
		browser text
			title: 'Source';
			when: [ :class :selector | class notNil and: [ selector notNil ] ];
			display: [ :class :selector | class sourceCodeAt: selector ].
		browser text
			title: 'Comment';
			display: [ :class :selector | class comment ] ].
		
	^ browser! !

!SGLCodeBrowser methodsFor: 'accessing' stamp: 'AndreiChis 7/15/2010 17:37'!
model
	^ Integer! !

!SGLComponent classSide methodsFor: 'initialization' stamp: 'lr 8/25/2009 15:26'!
registerAsApplication: aString
	| application |
	application := WAAdmin register: self asApplicationAt: aString.
	application configuration
		addParent: WADevelopmentConfiguration instance;
		at: #rootDecorationClasses put: #().
	application 
		addLibrary: JQGoogleLibrary;
		addLibrary: JQUiGoogleLibrary;
		addLibrary: JQRedmondTheme.
	^ application! !

!SGLComponent methodsFor: 'accessing' stamp: 'lr 2/26/2009 20:36'!
browser
	"Override this method and answer a browser instance."
	
	self subclassResponsibility! !

!SGLComponent methodsFor: 'accessing' stamp: 'lr 6/25/2009 13:20'!
model
	"Override this method and answer a model instance."
	
	^ nil! !

!SGLComponent methodsFor: 'private' stamp: 'lr 2/27/2009 10:13'!
presentation
	presentation isNil ifTrue: [
		presentation := self browser 
			startOn: self model;
			yourself ].
	^ presentation! !

!SGLComponent methodsFor: 'rendering' stamp: 'lr 2/28/2009 13:18'!
renderContentOn: html
	(SGLRenderer in: self on: html)
		render: self presentation! !

!SGLComponent methodsFor: 'updating' stamp: 'AndreiChis 7/27/2010 18:04'!
updateRoot: aHtmlRoot
	super updateRoot: aHtmlRoot.
	aHtmlRoot title: 'Seaside Glamorous Browser'.
	aHtmlRoot stylesheet url: (SGLFileLibrary urlOf: #styleCss).
	aHtmlRoot javascript url: (SGLFileLibrary urlOf: #glamourSeasideJs)
	"aHtmlRoot javascript url: 'http://getfirebug.com/releases/lite/1.2/firebug-lite-compressed.js'"! !

SGLComponent subclass: #SGLComposedTabulator
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Seaside-Examples-Dev'!

!SGLComposedTabulator classSide methodsFor: 'as yet unclassified' stamp: 'AndreiChis 5/31/2010 00:10'!
initialize
	self registerAsApplication: 'glamour/tabulator/composedTabulator'! !

!SGLComposedTabulator methodsFor: 'as yet unclassified' stamp: 'AndreiChis 7/6/2010 00:06'!
browser
		|browser|

	browser := GLMTabulator new.
	browser column:  #tab; column: #accordion; column: #stack.

	browser transmit  to: #tab; andShow: [ :a |
		a title: 'Tab arrangement'.
		a list
			title: 'First';
			showOnly: 10;
			display:  [ :x | 1 to: x ].
		a list
			title: 'Second';
			showOnly: 60;
			display:  [ :x | 1 to: x ].
		a list
			title: 'Third';
			display:  [ :x | 1 to: x ] ].

	browser transmit  to: #accordion; andShow: [ :a |
		a accordionArrangement.
		a title: 'Accordion arrangement'.
		a list
			title: 'First';
			showOnly: 10;
			display:  [ :x | 1 to: x ].
		a list
			title: 'Second';
			showOnly: 60;
			display:  [ :x | 1 to: x ].
		a list
			title: 'Third';
			display:  [ :x | 1 to: x ] ].
		
	browser transmit  to: #stack; andShow: [ :a |
		a stackedVerticallyArrangement.
		a title: 'Stack arrangment'.
		a list
			title: 'First';
			showOnly: 10;
			display:  [ :x | 1 to: x ].
		a list
			title: 'Second';
			showOnly: 60;
			display:  [ :x | 1 to: x ].
		a list
			title: 'Third';
			display:  [ :x | 1 to: x ] ].
		
	^browser ! !

!SGLComposedTabulator methodsFor: 'as yet unclassified' stamp: 'AndreiChis 7/5/2010 23:54'!
model
	^ 1000
! !

SGLComponent subclass: #SGLComposedTabulatorWithActions
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Seaside-Examples-Dev'!

!SGLComposedTabulatorWithActions classSide methodsFor: 'as yet unclassified' stamp: 'AndreiChis 7/16/2010 20:00'!
initialize
	self registerAsApplication: 'glamour/actions/composedTabulatorWithAction'! !

!SGLComposedTabulatorWithActions methodsFor: 'as yet unclassified' stamp: 'AndreiChis 7/16/2010 20:24'!
browser
		|browser|

	browser := GLMTabulator new.
	browser column:  #tab; column: #accordion; column: #stack.

	browser transmit  to: #tab; andShow: [ :a |
		a title: 'Tab arrangement'.
		a act: [:list :entity| Transcript show: 'Tab arrangement action 1'; cr ] icon: MenuIcons jumpIcon entitled: 'Tab arrangement action 1'.
		a act: [:list :entity| Transcript show: 'Tab arrangement action 2'; cr ] icon: MenuIcons helpIcon  entitled: 'Tab arrangement action 2'.
		a list
			title: 'First';
			showOnly: 10;
			act: [:list :entity| Transcript show: 'First tab action 1'; cr ] icon: MenuIcons projectIcon entitled: 'First tab action 1';
			act: [:list :entity| Transcript show: 'First tab action 2'; cr ] icon: MenuIcons jumpIcon entitled: 'First tab action 2';
			act: [:list :entity| Transcript show: 'First tab action 3'; cr ] icon: MenuIcons paintIcon entitled: 'First tab action 3';
			display:  [ :x | 1 to: x ].
		a list
			title: 'Second';
			showOnly: 60;
			act: [:list :entity| Transcript show: 'Second tab action 1'; cr ] icon: MenuIcons publishIcon entitled: 'Second tab action 1';
			act: [:list :entity| Transcript show: 'Second tab action 2'; cr ] icon: MenuIcons paintTabIcon entitled: 'Second tab action 2';
			display:  [ :x | 1 to: x ].
		a list
			title: 'Third';
			act: [:list :entity| Transcript show: 'Third tab action 1'; cr ] icon: MenuIcons projectIcon entitled: 'Third tab action 1';
			act: [:list :entity| Transcript show: 'Third tab action 2'; cr ] icon: MenuIcons jumpIcon entitled: 'Third tab action 2';
			act: [:list :entity| Transcript show: 'Third tab action 3'; cr ] icon: MenuIcons paintTabIcon entitled: 'Third tab action 3';
			act: [:list :entity| Transcript show: 'Third tab action 4'; cr ] icon: MenuIcons publishIcon entitled: 'Third tab action 4';
			display:  [ :x | 1 to: x ] ].

	browser transmit  to: #accordion; andShow: [ :a |
		a accordionArrangement.
		a act: [:list :entity| Transcript show: 'Accordion arrangement action 1'; cr ] icon: MenuIcons jumpIcon entitled: 'Accordion arrangement action 1'.
		a title: 'Accordion arrangement'.
		a list
			title: 'First';
			showOnly: 10;
			act: [:list :entity| Transcript show: 'First accordion tab action 1'; cr ] icon: MenuIcons projectIcon entitled: 'First accordion tab action 1';
			act: [:list :entity| Transcript show: 'First accordion tab action 2'; cr ] icon: MenuIcons jumpIcon entitled: 'First accordion tab action 2';
			act: [:list :entity| Transcript show: 'First accordion tab action 3'; cr ] icon: MenuIcons paintTabIcon entitled: 'First accordion tab action 3';
			display:  [ :x | 1 to: x ].
		a list
			title: 'Second';
			showOnly: 60;
			act: [:list :entity| Transcript show: 'Second accordion tab action 1'; cr ] icon: MenuIcons projectIcon entitled: 'Second accordion tab action 1';
			act: [:list :entity| Transcript show: 'Second accordion tab action 2'; cr ] icon: MenuIcons jumpIcon entitled: 'Second accordion tab action 2';
			act: [:list :entity| Transcript show: 'Second accordion tab action 3'; cr ] icon: MenuIcons paintTabIcon entitled: 'Second accordion tab action 3';
			display:  [ :x | 1 to: x ].
		a list
			title: 'Third';
			display:  [ :x | 1 to: x ] ].
		
	browser transmit  to: #stack; andShow: [ :a |
		a stackedVerticallyArrangement.
		a act: [:list :entity| Transcript show: 'Stacked arrangement action 1'; cr ] icon: MenuIcons jumpIcon entitled: 'Stacked arrangement action 1'.
		a title: 'Stack arrangment'.
		a list
			title: 'First';
			showOnly: 10;
			act: [:list :entity| Transcript show: 'First stacked tab action 1'; cr ] icon: MenuIcons projectIcon entitled: 'First stacked tab action 1';
			act: [:list :entity| Transcript show: 'First stacked tab action 2'; cr ] icon: MenuIcons jumpIcon entitled: 'First stacked tab action 2';
			act: [:list :entity| Transcript show: 'First stacked tab action 3'; cr ] icon: MenuIcons paintTabIcon entitled: 'First stacked tab action 3';
			display:  [ :x | 1 to: x ].
		a list
			title: 'Second';
			act: [:list :entity| Transcript show: 'Second stacked tab action 1'; cr ] icon: MenuIcons projectIcon entitled: 'Second stacked tab action 1';
			act: [:list :entity| Transcript show: 'Second stacked tab action 2'; cr ] icon: MenuIcons jumpIcon entitled: 'Second stacked tab action 2';
			act: [:list :entity| Transcript show: 'Second stacked tab action 3'; cr ] icon: MenuIcons paintTabIcon entitled: 'Second stacked tab action 3';
			showOnly: 60;
			display:  [ :x | 1 to: x ].
		a list
			title: 'Third';
			act: [:list :entity| Transcript show: 'Third stacked tab action 1'; cr ] icon: MenuIcons projectIcon entitled: 'Third stacked tab action 1';
			act: [:list :entity| Transcript show: 'Third stacked tab action 2'; cr ] icon: MenuIcons jumpIcon entitled: 'Third stacked tab action 2';
			act: [:list :entity| Transcript show: 'Third stacked tab action 3'; cr ] icon: MenuIcons paintTabIcon entitled: 'Third stacked tab action 3';
			display:  [ :x | 1 to: x ] ].
		
	^browser ! !

!SGLComposedTabulatorWithActions methodsFor: 'as yet unclassified' stamp: 'AndreiChis 7/16/2010 20:00'!
model
	^ 100
! !

SGLComponent subclass: #SGLDefaultComponent
	instanceVariableNames: ''
	classVariableNames: 'SGLBrowser SGLModel'
	poolDictionaries: ''
	category: 'Glamour-Seaside-Core'!

!SGLDefaultComponent classSide methodsFor: 'initialization' stamp: 'lr 8/25/2009 13:07'!
initialize
	| application |
	application := self registerAsApplication: 'glamour/pluggable'.
	application parent defaultName: application name! !

!SGLDefaultComponent classSide methodsFor: 'public' stamp: 'lr 8/25/2009 13:13'!
register: aBrowser on: aModel
	SGLBrowser := aBrowser.
	SGLModel := aModel! !

!SGLDefaultComponent methodsFor: 'accessing' stamp: 'lr 8/25/2009 13:04'!
browser
	^ SGLBrowser! !

!SGLDefaultComponent methodsFor: 'accessing' stamp: 'lr 8/25/2009 13:03'!
model
	^ SGLModel! !

SGLComponent subclass: #SGLDifferentComposites
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Seaside-Examples'!

!SGLDifferentComposites classSide methodsFor: 'initialization' stamp: 'AndreiChis 5/29/2010 12:35'!
initialize
	self registerAsApplication: 'glamour/basicExamples/differentComposites'! !

!SGLDifferentComposites methodsFor: 'as yet unclassified' stamp: 'AndreiChis 5/29/2010 12:38'!
browser
	^GLMBasicExamples new differentComposites! !

!SGLDifferentComposites methodsFor: 'as yet unclassified' stamp: 'AndreiChis 5/29/2010 12:38'!
model
	^ (1 to: 100)! !

SGLComponent subclass: #SGLFileBrowser
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Seaside-Examples'!

!SGLFileBrowser classSide methodsFor: 'initialization' stamp: 'lr 8/25/2009 17:23'!
initialize
	self registerAsApplication: 'glamour/file'! !

!SGLFileBrowser methodsFor: 'accessing' stamp: 'tg 4/22/2010 00:27'!
browser
	| browser |
	browser := GLMTabulator new.
	browser 
		column: #folders;
		column: [ :column | column row: #files span: 2; row: #summary ] span: 2.

	browser showOn: #folders; using: [
		browser tree 
			title: 'Folders'; 
			children: [ :directory | 
				directory directoryNames
					collect: [ :each | directory directoryNamed: each ] ];
			format: [ :directory | directory localName ] ].

	browser showOn: #files; from: #folders; using: [
		browser list
			display: [ :directory | 
				directory fileNames
					collect: [ :each | directory directoryNamed: each ] ];
			format: [ :directory | directory localName ] ].

	browser showOn: #summary; from: #files; using: [
		browser text 
			title: 'Summary';
			display: [ :directory |
				| stream |
				stream := FileStream oldFileNamed: directory pathName.
				[ (stream binary; next: 2000) asString ] 
					ensure: [ stream close ] ] ].

	^ browser! !

!SGLFileBrowser methodsFor: 'accessing' stamp: 'lr 2/27/2009 15:56'!
model
	^ FileDirectory default containingDirectory ! !

SGLComponent subclass: #SGLFinderWithTabulator
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Seaside-Examples-Dev'!

!SGLFinderWithTabulator classSide methodsFor: 'as yet unclassified' stamp: 'AndreiChis 7/6/2010 00:21'!
initialize
	self registerAsApplication: 'glamour/finder/finderWithTabulator'! !

!SGLFinderWithTabulator methodsFor: 'as yet unclassified' stamp: 'AndreiChis 7/6/2010 00:10'!
browser
	|innerBrowser finder|
	innerBrowser := GLMTabulator new.
	innerBrowser row: #methods; row: #source.
	innerBrowser transmit to: #methods; andShow: [ :a | 
		a list
			title: [:each | 'Methods invoking ', each name ];
			display: #invokingMethods ;
			showOnly: 50;
			format: #mooseName ].
	innerBrowser transmit from: #methods; to: #source; andShow: [:a |
		a text display: #sourceText ].
	
	innerBrowser transmit from: #methods; toOutside: #selection.
	
	finder  := GLMFinder new.
	finder title: [ :each | 'Reference browser on ', each mooseName ].
	finder show: [ :a |
		a custom: innerBrowser ].
	
	^finder! !

!SGLFinderWithTabulator methodsFor: 'as yet unclassified' stamp: 'AndreiChis 6/4/2010 19:02'!
model
	 ^ (MooseModel root allModels first allMethods entityNamed: #'org::argouml::model::Facade.getName()' )! !

SGLComponent subclass: #SGLListTags
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Seaside-Examples-Dev'!

!SGLListTags classSide methodsFor: 'as yet unclassified' stamp: 'AndreiChis 7/17/2010 22:20'!
initialize
	self registerAsApplication: 'glamour/tags/listTags'! !

!SGLListTags methodsFor: 'as yet unclassified' stamp: 'AndreiChis 7/18/2010 18:22'!
browser
	|browser |

	browser := GLMTabulator new.
	browser column: #one; column: #two.
	browser showOn: #one; using: [
		browser tree
			showOnly: 10;
			tags: [:each | 
				{each even ifTrue: ['even'] ifFalse: ['odd'].
				(each\\3 == 0 ) ifTrue: ['div 3'] ifFalse: ['not div 3'].
				(each\\4 == 0 ) ifTrue: ['div 4'] ifFalse: ['not div 4'].
				(each\\5 == 0 ) ifTrue: ['div 5'] ifFalse: ['not div 5']}
				]].
	browser showOn: #two; from: #one; using: [
		browser text
			display: [:x | 'You have selected ', x printString ]].
	^ browser! !

!SGLListTags methodsFor: 'as yet unclassified' stamp: 'AndreiChis 7/18/2010 19:27'!
model
	^ 1 to: 103! !

SGLComponent subclass: #SGLLongTabulator
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Seaside-Examples-Dev'!

!SGLLongTabulator classSide methodsFor: 'as yet unclassified' stamp: 'AndreiChis 7/5/2010 23:09'!
initialize
	self registerAsApplication: 'glamour/tabulator/longTabulator'! !

!SGLLongTabulator methodsFor: 'as yet unclassified' stamp: 'AndreiChis 7/5/2010 23:19'!
browser
	|browser|
	browser := GLMTabulator new.
	browser column:  #col1; column:  #col2; column: #col3.
	browser transmit to: #col1; andShow: [ :a | 
		a list
			title: [:each | 'Methods invoking ', each name ];
			display: #invokingMethods ;
			format: #mooseName;
			showOnly: 30 ].
	browser transmit to: #col2; andShow: [ :a | 
		a list
			title: [:each | 'Methods invoking ', each name ];
			display: #invokingMethods ;
			format: #mooseName;
			showOnly: 200 ].
	browser transmit to: #col3; andShow: [ :a | 
		a list
			title: [:each | 'Methods invoking ', each name ];
			display: #invokingMethods ;
			format: #mooseName ].
	
	^browser! !

!SGLLongTabulator methodsFor: 'as yet unclassified' stamp: 'AndreiChis 7/5/2010 23:09'!
model
	^ (MooseModel root allModels first allMethods entityNamed: #'org::argouml::model::Facade.getName()' )! !

SGLComponent subclass: #SGLOnePaneMultipleTabPresentations
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Seaside-Examples-Dev'!

!SGLOnePaneMultipleTabPresentations classSide methodsFor: 'as yet unclassified' stamp: 'AndreiChis 5/29/2010 00:33'!
initialize
	self registerAsApplication: 'glamour/tabulator/onePaneWithMultipleTabs'! !

!SGLOnePaneMultipleTabPresentations methodsFor: 'as yet unclassified' stamp: 'AndreiChis 7/6/2010 00:08'!
browser
	|browser|

	browser := GLMTabulator new.
	browser row: #justARow.

	browser transmit  to: #justARow; andShow: [ :a |
		a title: 'Presentare'.
		a list
			title: 'First';
			showOnly: 10;
			display:  [ :x | 1 to: x ].
		a list
			title: 'Second';
			showOnly: 60;
			display:  [ :x | 1 to: x ].
		a list
			title: 'Third';
			showOnly: 300;
			display:  [ :x | 1 to: x ] .
		a list
			title: 'Fourth';
			showOnly: 524;
			display:  [ :x | 1 to: x ] .
		a list
			title: 'Fifth';
			display:  [ :x | 1 to: x ] ].
		
	^browser ! !

!SGLOnePaneMultipleTabPresentations methodsFor: 'as yet unclassified' stamp: 'AndreiChis 7/6/2010 00:07'!
model
	^ 1000! !

SGLComponent subclass: #SGLOnePaneTabulator
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Seaside-Examples-Dev'!

!SGLOnePaneTabulator classSide methodsFor: 'initialization' stamp: 'AndreiChis 5/28/2010 23:46'!
initialize
	self registerAsApplication: 'glamour/tabulator/onePaneWithoutPresentation'! !

!SGLOnePaneTabulator methodsFor: 'as yet unclassified' stamp: 'AndreiChis 6/5/2010 19:14'!
browser
	| browser |
	browser := GLMTabulator new.
	browser row: #justARow.
	
	browser showOn: #justARow; using:[ browser list display: [:x | 1 to: x]].
	
	^browser! !

!SGLOnePaneTabulator methodsFor: 'as yet unclassified' stamp: 'AndreiChis 5/28/2010 23:45'!
model
	^ 100! !

SGLComponent subclass: #SGLOnePaneWithTitle
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Seaside-Examples-Dev'!

!SGLOnePaneWithTitle classSide methodsFor: 'as yet unclassified' stamp: 'AndreiChis 5/30/2010 21:03'!
initialize
	self registerAsApplication: 'glamour/tabulator/onePaneWithTitle'! !

!SGLOnePaneWithTitle methodsFor: 'as yet unclassified' stamp: 'AndreiChis 7/6/2010 00:09'!
browser
	|browser|
	
	browser := GLMTabulator new.
	browser row: #justARow.
	browser title: 'Tabulator'.
	
	browser transmit to: #justARow; andShow: [ :a |
		a list
			showOnly: 20;
			title: 'A list presentation';
			display:  [ :x | 1 to: x ] ].
	
	
	^browser 
	
! !

!SGLOnePaneWithTitle methodsFor: 'as yet unclassified' stamp: 'AndreiChis 5/30/2010 21:03'!
model
	^ 100! !

SGLComponent subclass: #SGLPierBrowser
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Seaside-Examples'!

!SGLPierBrowser classSide methodsFor: 'initialization' stamp: 'lr 8/25/2009 17:23'!
initialize
	self registerAsApplication: 'glamour/pier'! !

!SGLPierBrowser methodsFor: 'accessing' stamp: 'tg 4/22/2010 00:27'!
browser
	| browser |
	browser := GLMTabulator new.
	browser column: [:c | c row: #navigation; row: #map ];
			column: #editor span: 4.
	browser showOn: #navigation; using: [
		browser tree
			children: [ :page | page enumerator contents ];
			format: [ :page | page title ] ].
	browser showOn: #map; using: [
		browser mondrian
			painting: [ :view :page |
				view nodeShape: (MORectangleShape new height: [ :each | each document text size // 50 + 20 ]; width: [ :each | each document text size // 50 + 20 ]).
				view nodes: page root enumerator all.
				view edgesFrom: #parent.
				view treeLayout ]
	].
	browser showOn: #editor; from: #navigation; using: [
		browser magritte ].
	browser showOn: #editor; from: #map; using: [
		browser magritte ].
	^ browser ! !

!SGLPierBrowser methodsFor: 'accessing' stamp: 'lr 5/6/2009 12:44'!
model
	^ PRKernel instances anyOne root! !

SGLComponent subclass: #SGLSTPackageBrowser
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Seaside-Examples'!

!SGLSTPackageBrowser classSide methodsFor: 'initialization' stamp: 'tg 8/31/2009 17:02'!
initialize
	self registerAsApplication: 'glamour/package'! !

!SGLSTPackageBrowser methodsFor: 'as yet unclassified' stamp: 'tg 8/31/2009 17:01'!
browser
	^ GLMSTBrowserExample new browser! !

!SGLSTPackageBrowser methodsFor: 'as yet unclassified' stamp: 'tg 8/31/2009 17:01'!
model
	^ BrowserEnvironment new forPackageNamed: 'Glamour'! !

SGLComponent subclass: #SGLSimpleFinder
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Seaside-Examples'!

!SGLSimpleFinder classSide methodsFor: 'initialization' stamp: 'AndreiChis 6/5/2010 13:07'!
initialize
	self registerAsApplication: 'glamour/basicExamples/simpleFinder'! !

!SGLSimpleFinder methodsFor: 'as yet unclassified' stamp: 'AndreiChis 6/5/2010 13:08'!
browser
	| finder |
	finder := GLMFinder new.
	finder title: 'Finder'.
	finder show: [ :a |
		a list 
			display: [:x | 1 to: x] ].
		
	^finder.! !

!SGLSimpleFinder methodsFor: 'as yet unclassified' stamp: 'AndreiChis 6/5/2010 13:07'!
model
	^100! !

SGLComponent subclass: #SGLSimpleTree
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Seaside-Examples-Dev'!

!SGLSimpleTree classSide methodsFor: 'as yet unclassified' stamp: 'AndreiChis 7/7/2010 22:41'!
initialize
	self registerAsApplication: 'glamour/tabulator/simpleTreePresentation'! !

!SGLSimpleTree methodsFor: 'as yet unclassified' stamp: 'AndreiChis 7/16/2010 16:05'!
browser
	|browser|

	browser := GLMTabulator new.
	browser column: #one.
	browser showOn: #one; using: [
		browser tree
			title: 'No expansion';
			children: [:item | 1 to: 4];
			showOnly: 10.
		browser tree
			title: 'Roots expanded';
			rootsExpanded;
			children: [:item | 1 to: 4];
			showOnly: 10 ].

	^ browser! !

!SGLSimpleTree methodsFor: 'as yet unclassified' stamp: 'AndreiChis 7/7/2010 22:41'!
model
	^ 1 to: 100! !

SGLComponent subclass: #SGLTabsWithActions
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Seaside-Examples-Dev'!

!SGLTabsWithActions classSide methodsFor: 'as yet unclassified' stamp: 'AndreiChis 7/15/2010 16:55'!
initialize
	self registerAsApplication: 'glamour/actions/tabsWithActions'! !

!SGLTabsWithActions methodsFor: 'as yet unclassified' stamp: 'AndreiChis 7/15/2010 16:59'!
browser
	|browser|
	
	browser := GLMTabulator new.
	browser column: #aColumn.

	browser transmit  to: #aColumn; andShow: [ :a |
		a title: 'Tab arrangement'.
		a list
			title: 'First';
			showOnly: 10;
			display:  [ :x | 1 to: x ];
			act: [:list :entity| Transcript show: '+1'; cr ] entitled: '+1';
			act: [:list :entity| Transcript show: '+2'; cr ] entitled: '+2';
			act: [:list :entity| Transcript show: '+3'; cr ] entitled: '+3'.
		a list
			title: 'Second';
			showOnly: 60;
			display:  [ :x | 1 to: x ];
			act: [:list :entity| Transcript show: '-1'; cr ] entitled: '-1';
			act: [:list :entity| Transcript show: '-2'; cr ] entitled: '-2'.
		a list
			title: 'Third';
			display:  [ :x | 1 to: x ] ;
			act: [:list :entity| Transcript show: '*1'; cr ] entitled: '*1';
			act: [:list :entity| Transcript show: '*2'; cr ] entitled: '*2';
			act: [:list :entity| Transcript show: '*3'; cr ] entitled: '*3';
			act: [:list :entity| Transcript show: '*4'; cr ] entitled: '*4'  ].
	^browser! !

!SGLTabsWithActions methodsFor: 'as yet unclassified' stamp: 'AndreiChis 7/15/2010 16:54'!
model
	^ 18! !

SGLComponent subclass: #SGLTreeWithExpansion
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Seaside-Examples'!

!SGLTreeWithExpansion classSide methodsFor: 'as yet unclassified' stamp: 'AndreiChis 7/7/2010 19:43'!
initialize
	self registerAsApplication: 'glamour/basicExamples/treeWithExpansion'! !

!SGLTreeWithExpansion methodsFor: 'as yet unclassified' stamp: 'AndreiChis 7/7/2010 19:41'!
browser
	^ GLMBasicExamples new treeWithExpansion! !

!SGLTreeWithExpansion methodsFor: 'as yet unclassified' stamp: 'AndreiChis 7/7/2010 19:44'!
model
	^ #(($a $b $c $d) ($e $f) ($g $h $i $j ($l $m $n)))! !

SGLComponent subclass: #SGLTreeWithLeafTags
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Seaside-Examples-Dev'!

!SGLTreeWithLeafTags classSide methodsFor: 'as yet unclassified' stamp: 'AndreiChis 7/18/2010 13:23'!
initialize
	self registerAsApplication: 'glamour/tags/treeWithLeafTags'! !

!SGLTreeWithLeafTags methodsFor: 'as yet unclassified' stamp: 'AndreiChis 7/18/2010 13:35'!
browser
	|browser |
	browser := GLMTabulator new.
	browser column: #one; column: #two.
	browser showOn: #one; using: [
		browser tree
			title: 'No expansion';
			tags: [:each | 
				each isNumber 
				ifTrue: [
					{(each isNumber and: [each even]) ifTrue: ['even'] ifFalse: ['odd'].
					(each isNumber and: [each\\3 == 0] ) ifTrue: ['div 3'] ifFalse: ['not div 3'].
					(each isNumber and: [each\\4 == 0] ) ifTrue: ['div 4'] ifFalse: ['not div 4'].
					(each isNumber and: [each\\5 == 0] ) ifTrue: ['div 5'] ifFalse: ['not div 5']} ]
				ifFalse: [{}] ];
			children: [:x :i | x isCollection ifTrue: [x] ifFalse: [OrderedCollection new] ].
			
			
		browser tree
			title: 'All Expanded';
			allExpanded;
			tags: [:each | 
				each isNumber 
				ifTrue: [
					{(each isNumber and: [each even]) ifTrue: ['even'] ifFalse: ['odd'].
					(each isNumber and: [each\\3 == 0] ) ifTrue: ['div 3'] ifFalse: ['not div 3'].
					(each isNumber and: [each\\4 == 0] ) ifTrue: ['div 4'] ifFalse: ['not div 4'].
					(each isNumber and: [each\\5 == 0] ) ifTrue: ['div 5'] ifFalse: ['not div 5']} ]
				ifFalse: [{}] ];
			children: [:x :i | x isCollection ifTrue: [x] ifFalse: [OrderedCollection new] ] ].
	browser showOn: #two; from: #one; using: [ browser text ].
	^ browser! !

!SGLTreeWithLeafTags methodsFor: 'as yet unclassified' stamp: 'AndreiChis 7/18/2010 16:29'!
model
	^ #(
			(1 2 3 4) 
			(5 6 7 (8 9) (10 11) ( (12 13) (13 15) ) )
			 (16 17 18  (19 20 21 22))
		)! !

SGLComponent subclass: #SGLTreeWithTags
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Seaside-Examples-Dev'!

!SGLTreeWithTags classSide methodsFor: 'as yet unclassified' stamp: 'AndreiChis 7/18/2010 13:42'!
initialize
	self registerAsApplication: 'glamour/tags/treeWithTags'! !

!SGLTreeWithTags methodsFor: 'as yet unclassified' stamp: 'AndreiChis 7/18/2010 13:40'!
browser
	|browser |
	browser := GLMTabulator new.
	browser column: #one; column: #two.
	browser showOn: #one; using: [
		browser tree
			title: 'No expansion';
			tags: [:each | 
				each isNumber 
				ifTrue: [
					{each even ifTrue: ['even'] ifFalse: ['odd'] } ]
				ifFalse: [
					{each size even ifTrue: ['even'] ifFalse: ['odd'] } ] ];
			children: [:x :i | x isCollection ifTrue: [x] ifFalse: [OrderedCollection new] ].
			
		browser tree
			title: 'All Expanded';
			allExpanded;
			tags: [:each | 
				each isNumber 
				ifTrue: [
					{each even ifTrue: ['even'] ifFalse: ['odd'] } ]
				ifFalse: [
					{each size even ifTrue: ['even'] ifFalse: ['odd'] } ] ];
			children: [:x :i | x isCollection ifTrue: [x] ifFalse: [OrderedCollection new] ] ].
	browser showOn: #two; from: #one; using: [ browser text ].
	^ browser! !

!SGLTreeWithTags methodsFor: 'as yet unclassified' stamp: 'AndreiChis 7/18/2010 16:31'!
model
	^ #(
			(1 2 3 4) 
			(5 6 7 (8 9 99) (10 11) ( (12 13) (13 15) ) )
			 (16 17 18  (19 20 21 22) (23 24 25 26))
		)! !

SGLComponent subclass: #SGLVerySimpleFinder
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Seaside-Examples-Dev'!

!SGLVerySimpleFinder classSide methodsFor: 'as yet unclassified' stamp: 'AndreiChis 6/4/2010 14:03'!
initialize
	self registerAsApplication: 'glamour/finder/simpleFinder'! !

!SGLVerySimpleFinder methodsFor: 'as yet unclassified' stamp: 'AndreiChis 7/5/2010 23:47'!
browser
	| finder |
	finder := GLMFinder new.
	finder title: 'Finder'.
	finder show: [ :a |
		a list 
			showOnly: 30;
			title: 'A Finder';
			format: #mooseName;
			send: #providerNamespaces ].
		
	^finder.! !

!SGLVerySimpleFinder methodsFor: 'as yet unclassified' stamp: 'AndreiChis 6/4/2010 14:01'!
model
	^	MooseModel root allModels first allModelNamespaces! !

!Symbol methodsFor: '*glamour-seaside' stamp: 'lr 2/25/2009 16:10'!
fixCallbackTemps! !

Object subclass: #SGLRenderer
	instanceVariableNames: 'component html uuid scripts properties'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Seaside-Core'!

!SGLRenderer classSide methodsFor: 'instance-creation' stamp: 'lr 2/26/2009 19:58'!
in: aComponent on: html
	^ self basicNew initializeIn: aComponent on: html! !

!SGLRenderer methodsFor: 'initialization' stamp: 'lr 11/6/2009 11:09'!
initialize
	super initialize.
	uuid := IdentityDictionary new.
	properties := IdentityDictionary new.
	scripts := GRSmallDictionary new! !

!SGLRenderer methodsFor: 'initialization' stamp: 'lr 2/27/2009 14:45'!
initializeIn: aComponent on: aRenderer
	self initialize.
	component := aComponent.
	html := aRenderer! !

!SGLRenderer methodsFor: 'dispatching' stamp: 'lr 3/11/2009 11:20'!
render: aRenderable
	aRenderable renderGlamorouslyOn: self! !

!SGLRenderer methodsFor: 'presentation' stamp: 'AndreiChis 7/16/2010 20:27'!
renderAccordionCompositePresentation: aCompositePresentation
	| presentations index |
	presentations := aCompositePresentation matchingPresentations.
	presentations isEmpty ifTrue: [ ^ self renderEmptyPresentation ].
	presentations size = 1 ifTrue: [ ^ self renderWithTitleOrNil: presentations first ].
	
	index := 1.
	presentations withIndexDo: [ :each :i | 
		aCompositePresentation pane lastActivePresentation notNil and: [ 
			each title = aCompositePresentation pane lastActivePresentation title ifTrue: [ index := i ] ] ].

	html div
		class: 'accordion-arrangement';
  	      script: (html jQuery new accordion animated: false; clearStyle: true; active: index-1);
   	      with: [
         		presentations withIndexDo: [ :each :i | 
				html div: [ html anchor: each title. self renderActionsFrom: each ].
				html div: [ self render: each ] ] ]! !

!SGLRenderer methodsFor: 'widgets' stamp: 'AndreiChis 7/15/2010 15:27'!
renderAccumulator: aBrowser
	|panes|
	panes := aBrowser panes.
	panes isEmpty ifTrue: [ ^ self renderEmptyPresentation ].
	aBrowser 
		when: GLMPaneAdded
		do: [ :ann | self renderAccumulator: aBrowser addPane: ann pane ].
	aBrowser 
		when: GLMPaneSelected
		do: [ :ann | self renderAccumulator: aBrowser selectPaneAt: ann position ].
	html div
		id: (self uuidFor: aBrowser);
		class: 'accumulator';
		script: ( (html jQuery this tabs cache: true)
					onSelect: (html jQuery ajax callbackTabs: [ :event | 
                    			aBrowser activeEntity: ((aBrowser panes at: (event at: #index) + 1) port: #entity) value ]) );
		with: [
			html unorderedList: [
				aBrowser panes withIndexDo: [ :each :i |
					self renderAccumulator: aBrowser pane: each at: i] ] ]! !

!SGLRenderer methodsFor: 'widgets' stamp: 'AndreiChis 7/16/2010 21:03'!
renderAccumulator: aBrowser addPane: aPane
	|tabs|
	tabs := (html jQuery id: (self uuidFor: aBrowser)).
	self scriptFor: aBrowser add: ( 
		(tabs tabs 
			add: (html jQuery ajax
						html: [ :renderer | 
							html := renderer.										
							self renderPaneWithoutTitle: aPane ];
						fullUrl) 			 
			label: ( self titleOrIconOf: aPane presentations) ),
		(tabs tabs select: aBrowser panes size-1) ).
! !

!SGLRenderer methodsFor: 'widgets' stamp: 'AndreiChis 7/16/2010 21:05'!
renderAccumulator: aBrowser pane: aPane at: index
	html listItem
		class: 'ui-tabs-selected' if: aBrowser panes size = index;  
		with: [ 
			html anchor
				url: (html jQuery ajax
					html: [ :renderer | 
						html := renderer.										
						self renderPaneWithoutTitle: aPane ];
					fullUrl);
				with: ( self titleOrIconOf: aPane presentations).
				self renderActionsFrom: aPane presentations ].
! !

!SGLRenderer methodsFor: 'widgets' stamp: 'AndreiChis 7/12/2010 18:12'!
renderAccumulator: aBrowser selectPaneAt: index
	self scriptFor: aBrowser add:  (
		 (html jQuery id: (self uuidFor: aBrowser)) tabs select: index-1 ).! !

!SGLRenderer methodsFor: 'widgets' stamp: 'AndreiChis 7/16/2010 20:08'!
renderAction: anAction from: aPresentation
	html image 
		form: anAction icon;
		id: html nextId;
		title: anAction title;
		onClick: ( html jQuery ajax
			callback: [:a | anAction actOn: aPresentation ] value: JQEvent new target;
			script: [:script| self updateScript: script ] )! !

!SGLRenderer methodsFor: 'widgets' stamp: 'AndreiChis 7/16/2010 20:07'!
renderActionsFrom: aPresentation
	html div
		class: 'glm-ac-container';
		with: [   
			(aPresentation allActions select: [:action | action hasIcon ] ) do: [ :action | self renderAction: action from: aPresentation] ]! !

!SGLRenderer methodsFor: 'widgets' stamp: 'AndreiChis 7/5/2010 21:21'!
renderEmptyPresentation
	html div
		class: 'ui-widget';
		class: 'ui-widget-content';
		class: 'ui-corner-all';
		class: 'empty-presentation'! !

!SGLRenderer methodsFor: 'widgets' stamp: 'AndreiChis 7/6/2010 01:21'!
renderFinder: aBrowser
   |container|
	aBrowser 
		when: GLMPaneRemoved
		do: [ :ann | self renderFinder: ann browser removePane: ann pane ].
	aBrowser
		when: GLMPaneAdded
		do: [ :ann | self renderFinder: ann browser addPane: ann pane ].
		
	html div
		id: (self uuidFor: aBrowser); 
		class: 'ui-widget'; class: 'finder';
		with: [
			aBrowser panes 
				do: [ :each | self renderFinder: aBrowser pane: each ] ] .! !

!SGLRenderer methodsFor: 'widgets' stamp: 'lr 8/25/2009 14:32'!
renderFinder: aBrowser addPane: aPane
	self scriptFor: aBrowser add: ((html jQuery id: (self uuidFor: aBrowser))
		append: [ :r | html := r. self renderFinder: aBrowser pane: aPane ])! !

!SGLRenderer methodsFor: 'widgets' stamp: 'AndreiChis 7/5/2010 23:21'!
renderFinder: aBrowser pane: aPane
	html div
		class: 'finder-pane ui-widget-content ui-corner-all';
		with: [ self render: aPane ]! !

!SGLRenderer methodsFor: 'widgets' stamp: 'lr 8/25/2009 14:24'!
renderFinder: aBrowser removePane: aPane
	self scriptFor: aBrowser add: ((html jQuery id: (self uuidFor: aBrowser))
		contents;
		filter: ':last';
		remove)! !

!SGLRenderer methodsFor: 'presentation' stamp: 'AndreiChis 7/16/2010 16:09'!
renderListPresentation: aPresentation
	|model|
	model := SGLTreeModel new.
	model glamourPresentation: aPresentation.
	self renderListingPresentation: model! !

!SGLRenderer methodsFor: 'presentation' stamp: 'AndreiChis 7/27/2010 21:35'!
renderListingPresentation: aPresentationModel
	|aPresentation treeRenderer|
	aPresentation := aPresentationModel glamourPresentation.
	treeRenderer := (SGLTreePresenter for:  aPresentationModel with: self).
	treeRenderer htmlId: (self uuidFor: aPresentation).
	
	"When the morph changes, we want to update the glamour model"
	aPresentationModel announcer on: GLMTreeMorphSelectionChanged do: [ :ann | 
		aPresentation announcer suspendAllWhile: [
			aPresentation selection: ann selectionValue.
			aPresentation selectionPath: ann selectionPathValue] ].
	"aPresentationModel announcer on: GLMTreeMorphStrongSelectionChanged do: [ :ann | 
		aPresentation strongSelection: ann strongSelectionValue ]."
	
	treeRenderer renderContentOn: html! !

!SGLRenderer methodsFor: 'presentation' stamp: 'lr 5/6/2009 13:48'!
renderMagrittePresentation: aPresentation
	| form |
	form := aPresentation displayValue asComponent
		addValidatedForm;
		onAnswer: [ :answer | aPresentation selection: answer ].
	html div
		class: 'magritte';
		with: form! !

!SGLRenderer methodsFor: 'presentation' stamp: 'AndreiChis 7/15/2010 17:54'!
renderMondrianPresentation: aPresentation
	| view canvas |
	view := MOViewRenderer new.
	aPresentation renderOn: view. 
	canvas := MOCanvas new. 
	canvas root: view root.
	canvas selected: (view 
		nodeForDomainValue: aPresentation selection 
		ifAbsent: [ nil ]).
	html image
		form: canvas imageForm;	
		style: 'position: relative';
		id: (self uuidFor: aPresentation);
		onClick: (html jQuery ajax 
			callback: [ :value |
			| coordinates element |
			coordinates := (value contents findTokens: $,)
				collect: [ :each | each asNumber ].
			element := canvas root elementAt: coordinates first @ coordinates second.
			aPresentation selection: (element isNil
				ifFalse: [ element model ]) ]
		value: (JSStream on: 'event.layerX+","+event.layerY');
		script: [ :script |
			self scriptFor: aPresentation put: ((html jQuery id: (self uuidFor: aPresentation))
				replaceWith: [ :r | html := r. self renderMondrianPresentation: aPresentation ]).
			self updateScript: script ])! !

!SGLRenderer methodsFor: 'widgets' stamp: 'AndreiChis 5/31/2010 14:01'!
renderPane: aPane
	aPane whenMatchingPresentationsChanged: [ :ann |
		self 
			scriptFor: aPane
			put: ((html jQuery id: (self uuidFor: aPane))
				html: [ :renderer |
					html := renderer.
					self renderWithTitleOrNil: aPane presentations]) ].
	self renderWithTitleOrNil: aPane presentations! !

!SGLRenderer methodsFor: 'widgets' stamp: 'AndreiChis 7/1/2010 19:33'!
renderPaneWithoutTitle: aPane
	aPane whenMatchingPresentationsChanged: [ :ann |
		self 
			scriptFor: aPane
			put: ((html jQuery id: (self uuidFor: aPane))
				html: [ :renderer |
					html := renderer.
					self render: aPane presentations]) ].
	self render: aPane presentations! !

!SGLRenderer methodsFor: 'presentation' stamp: 'AndreiChis 7/16/2010 19:34'!
renderStackedVerticallyCompositePresentation: aCompositePresentation
	| presentations|
	presentations := aCompositePresentation matchingPresentations.
	presentations isEmpty ifTrue: [ ^ self renderEmptyPresentation ].	
	presentations size = 1 ifTrue: [^ self renderWithTitleOrNil: presentations first ].
	

	html div 
		class: 'ui-widget ui-widget-content ui-corner-all';
		class: 'stacked-arrangement';
		with: [
			presentations do: [ :each | 
				self renderWithTitle: each ] ]! !

!SGLRenderer methodsFor: 'presentation' stamp: 'AndreiChis 7/16/2010 19:46'!
renderTabbedCompositePresentation: aCompositePresentation
	| presentations index|
	presentations := aCompositePresentation matchingPresentations.
	presentations isEmpty ifTrue: [ ^ self renderEmptyPresentation ].
	presentations size = 1 ifTrue: [^ self renderWithTitleOrNil: presentations first ].
	index := 0.
	presentations withIndexDo: [ :each :i | 
		aCompositePresentation pane lastActivePresentation notNil and: [ 
			each title = aCompositePresentation pane lastActivePresentation title ifTrue: [ index := i-1 ] ] ].
	
	html div
		class: 'tabbed-arrangement';
		script: ( ( html jQuery new tabs cache: true )
					onSelect: (html jQuery ajax callbackTabs: [ :event | 
       		             	aCompositePresentation pane lastActivePresentation: (aCompositePresentation matchingPresentations at: (event at: #index)+1 ) ]) ); 
		with: [
			html unorderedList: [
				presentations withIndexDo: [ :each :i|
					html listItem 
						class: 'ui-tabs-selected' if: i = index; 
						with: [
							html anchor
								url: (html jQuery ajax
									html: [ :renderer | 
										html := renderer.										
										self render: each ];
									fullUrl);
								with: each title.
							self renderActionsFrom: each ] ] ] ]! !

!SGLRenderer methodsFor: 'widgets' stamp: 'AndreiChis 5/31/2010 23:17'!
renderTableLayoutColumn: aCell inBrowser: aBrowser
	html div class: 'sgl-table'; class: 'sgl-table-vbox'; with: [
		aCell children 
			do: [ :each |
				| tag |
				tag := html div boxFlex: each span; style: 'position: relative;'.
				each hasId 
					ifTrue: [
						| pane |
						pane := aBrowser paneNamed: each id.
						tag id: (self uuidFor: pane); with: [ self render: pane ] ]
					ifFalse: [ 
						tag with: [ self renderTableLayoutRow: each inBrowser: aBrowser  ] ] ]
			separatedBy: [ html div class: 'sgl-table-split' ] ]! !

!SGLRenderer methodsFor: 'widgets' stamp: 'AndreiChis 6/3/2010 22:32'!
renderTableLayoutRow: aCell inBrowser: aBrowser
	html div class: 'sgl-table'; class: 'sgl-table-hbox'; with: [
		aCell children 
			do: [ :each |
				| tag |
				tag := html div boxFlex: each span; style: 'position: relative;'.
				each hasId 
					ifTrue: [
						| pane |
						pane := aBrowser paneNamed: each id.
						tag id: (self uuidFor: pane); with: [ self render: pane ] ]
					ifFalse: [ 
						tag with: [ self renderTableLayoutColumn: each inBrowser: aBrowser ] ] ]
			separatedBy: [ html div class: 'sgl-table-split' ] ]! !

!SGLRenderer methodsFor: 'widgets' stamp: 'AndreiChis 5/31/2010 23:33'!
renderTabulator: aBrowser
	aBrowser cell isRow
		ifTrue: [ self renderTableLayoutRow: aBrowser cell inBrowser: aBrowser  ]
		ifFalse: [ self renderTableLayoutColumn: aBrowser cell inBrowser: aBrowser  ]! !

!SGLRenderer methodsFor: 'presentation' stamp: 'AndreiChis 7/17/2010 23:08'!
renderTextPresentation: aPresentation
	self widgetContainer
		class: 'presentation-container';
		with: [
			html textArea
				value: aPresentation formatedDisplayValue;
				callback: [ :value | aPresentation text: value ];
				onChange: (html jQuery ajax 
					serializeThis;
					script: [ :script | self updateScript: script ]) ]! !

!SGLRenderer methodsFor: 'presentation' stamp: 'AndreiChis 7/16/2010 16:13'!
renderTreePresentation: aPresentation
	|model|
	model := SGLTreeModel new.
	model glamourPresentation: aPresentation.
	model shouldRootsExpand: aPresentation shouldRootsExpand.
	model shouldAllExpand: aPresentation shouldAllExpand.
	self renderListingPresentation: model! !

!SGLRenderer methodsFor: 'widgets' stamp: 'AndreiChis 7/16/2010 20:04'!
renderWithTitle: aPresentation
	self widgetContainer 
		class: 'presentation-with-title';
		with: [
			html unorderedList				
				class: 'ui-tabs-nav ui-corner-all ui-helper-reset';
				class: 'presentation-title';
				with: [
					html listItem 
						class: 'ui-state-default ui-corner-top ui-tabs-selected';
						with: [ 
							html span: (aPresentation titleValue ifNil: ['&nbsp']).
							self renderActionsFrom: aPresentation ]
					].
			html div				
				class: 'ui-tabs-panel ui-widget-content ui-corner-bottom';
				class: 'presentation-content';
				with: [
					self render: aPresentation] ] ! !

!SGLRenderer methodsFor: 'widgets' stamp: 'AndreiChis 7/16/2010 19:29'!
renderWithTitleOrNil: aPresentation
	aPresentation hasTitle ifFalse: [^self render: aPresentation ].
	self renderWithTitle: aPresentation ! !

!SGLRenderer methodsFor: 'presentation' stamp: 'lr 3/11/2009 11:25'!
renderWorkspacePresentation: aWorkspacePresentation
	self renderTextPresentation: aWorkspacePresentation! !

!SGLRenderer methodsFor: 'script' stamp: 'lr 8/25/2009 14:20'!
scriptFor: anObject add: aScript
	(scripts at: (self uuidFor: anObject) ifAbsentPut: [ JSScript new ]) , aScript! !

!SGLRenderer methodsFor: 'script' stamp: 'lr 8/25/2009 14:04'!
scriptFor: anObject put: aScript
	scripts at: (self uuidFor: anObject) put: aScript! !

!SGLRenderer methodsFor: 'widgets' stamp: 'AndreiChis 7/16/2010 19:45'!
titleOrIconOf: aPresentation
	^aPresentation titleValue ifNil: ['']! !

!SGLRenderer methodsFor: 'script' stamp: 'AndreiChis 7/12/2010 18:24'!
updateScript: aScript
	aScript addAll: scripts values.
	aScript add: (JSStream on: 'Glamour.resize()').
	scripts := GRSmallDictionary new! !

!SGLRenderer methodsFor: 'script' stamp: 'lr 2/27/2009 14:54'!
uuidFor: anObject
	^ uuid at: anObject ifAbsentPut: [ html nextId ]! !

!SGLRenderer methodsFor: 'widgets' stamp: 'AndreiChis 5/30/2010 21:30'!
widgetContainer
	^ html div
		class: 'ui-widget';
		class: 'ui-widget-content';
		class: 'ui-corner-all';
		yourself! !

Object subclass: #SGLTreeModel
	instanceVariableNames: 'roots glamourPresentation amountToShow amountShown tagsToFilterBy shouldRootsExpand shouldAllExpand announcer selection'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Seaside-Core'!

!SGLTreeModel methodsFor: 'accessing' stamp: 'AndreiChis 7/15/2010 21:39'!
amountShown
	^ amountShown ifNil: [amountShown := 0]! !

!SGLTreeModel methodsFor: 'accessing' stamp: 'AndreiChis 7/15/2010 22:24'!
amountShown: anInteger
	amountShown := anInteger ! !

!SGLTreeModel methodsFor: 'accessing' stamp: 'AndreiChis 7/17/2010 17:08'!
amountToShow 
	amountToShow ifNil: [
		amountToShow := self glamourPresentation  amountToShow ifNil: [self roots size] ].
	(amountToShow + self amountShown ) > self roots size
		ifTrue: [amountToShow := self roots size - self amountShown ].
	^ amountToShow 
	! !

!SGLTreeModel methodsFor: 'as yet unclassified' stamp: 'AndreiChis 7/20/2010 16:20'!
announce: anAnnouncement
	self announcer announce: anAnnouncement ! !

!SGLTreeModel methodsFor: 'accessing' stamp: 'AndreiChis 7/20/2010 16:19'!
announcer
	^ announcer ifNil: [announcer := GLMAnnouncer new]! !

!SGLTreeModel methodsFor: 'accessing' stamp: 'AndreiChis 7/15/2010 20:04'!
glamourPresentation
	^ glamourPresentation ! !

!SGLTreeModel methodsFor: 'accessing' stamp: 'AndreiChis 7/15/2010 20:04'!
glamourPresentation: anObject
	glamourPresentation := anObject ! !

!SGLTreeModel methodsFor: 'accessing' stamp: 'AndreiChis 7/17/2010 16:53'!
nodeModelFor: anObject
	^ (SGLTreeNodeModel with: anObject) containerTree: self; yourself! !

!SGLTreeModel methodsFor: 'accessing' stamp: 'AndreiChis 7/18/2010 15:07'!
roots
	roots ifNil: [ self roots: self glamourPresentation displayValue ].
	^ roots select: [ :each | each shouldBeDisplayed ]. "This result should be chached as this method is often called"
	! !

!SGLTreeModel methodsFor: 'accessing' stamp: 'AndreiChis 7/18/2010 15:03'!
roots: anObjectOrCollection
	roots := anObjectOrCollection isCollection 
		ifTrue: [ anObjectOrCollection collect: [:each | self nodeModelFor: each ] ]
		ifFalse: [ OrderedCollection with: (self nodeModelFor: anObjectOrCollection) ]! !

!SGLTreeModel methodsFor: 'selection' stamp: 'AndreiChis 7/20/2010 21:29'!
selectedNodePath
	^ selection ifNotNil: [selection lastSelectedNodePath]! !

!SGLTreeModel methodsFor: 'selection' stamp: 'AndreiChis 7/20/2010 21:08'!
selection 
	^ selection! !

!SGLTreeModel methodsFor: 'selection' stamp: 'AndreiChis 7/27/2010 17:55'!
selection: aSelection 
	self selection = aSelection ifTrue: [ ^ self ].
	selection := aSelection.
	self announcer announce: (
			GLMTreeMorphSelectionChanged new 
				selectionValue: (aSelection ifNotNil: [aSelection selectedItemOrItemsOrNil]);
				selectionPathValue: self selectionPathItems;
				yourself)! !

!SGLTreeModel methodsFor: 'selection' stamp: 'AndreiChis 7/20/2010 21:19'!
selectionPathItems
	^ self selectedNodePath isNil ifTrue: [nil] ifFalse: [self selectedNodePath collect: [:each | each item]]! !

!SGLTreeModel methodsFor: 'accessing' stamp: 'AndreiChis 7/16/2010 14:57'!
shouldAllExpand
	^ shouldAllExpand ifNil: [shouldAllExpand := false]! !

!SGLTreeModel methodsFor: 'accessing' stamp: 'AndreiChis 7/16/2010 14:57'!
shouldAllExpand: anObject
	shouldAllExpand := anObject! !

!SGLTreeModel methodsFor: 'as yet unclassified' stamp: 'AndreiChis 7/17/2010 21:51'!
shouldFilterByTag: aTag
	^ self tagsToFilterBy includes: aTag ! !

!SGLTreeModel methodsFor: 'accessing' stamp: 'AndreiChis 7/16/2010 14:58'!
shouldRootsExpand
	^ shouldRootsExpand ifNil: [shouldRootsExpand := false]! !

!SGLTreeModel methodsFor: 'accessing' stamp: 'AndreiChis 7/16/2010 14:57'!
shouldRootsExpand: anObject
	shouldRootsExpand := anObject! !

!SGLTreeModel methodsFor: 'accessing' stamp: 'AndreiChis 7/17/2010 21:49'!
tagsToFilterBy
	^ tagsToFilterBy ifNil: [ tagsToFilterBy := OrderedCollection new ]! !

!SGLTreeModel methodsFor: 'as yet unclassified' stamp: 'AndreiChis 7/17/2010 21:51'!
toggleFilteringByTag: aTag 
	(self shouldFilterByTag: aTag) 
		ifTrue: [self tagsToFilterBy remove: aTag ]
		ifFalse: [self tagsToFilterBy add: aTag].
	self updateRoots ! !

!SGLTreeModel methodsFor: 'accessing' stamp: 'AndreiChis 7/18/2010 19:25'!
updateRoots
	amountToShow := nil. "This value is cached"
	"roots := nil."
	"self roots"! !

Object subclass: #SGLTreeNodeModel
	instanceVariableNames: 'item containerTree parentNode childrens expanded rendered htmlId'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Seaside-Core'!

!SGLTreeNodeModel classSide methodsFor: 'instance creation' stamp: 'AndreiChis 7/17/2010 17:01'!
with: anObject
	^ self new item: anObject ! !

!SGLTreeNodeModel methodsFor: 'accessing' stamp: 'AndreiChis 7/18/2010 15:02'!
childrenItems
	^ childrens ifNil: [ 
		| allContents |
		allContents :=  (self containerTree glamourPresentation childrenValueOf: self item atLevel: self path size) ifNil: [OrderedCollection new].
		childrens := allContents collect: [ :d | 
			(self class with: d)
				parentNode: self;
				containerTree: self containerTree;
				yourself ] ].
	! !

!SGLTreeNodeModel methodsFor: 'accessing' stamp: 'AndreiChis 7/17/2010 17:05'!
containerTree
	^ containerTree! !

!SGLTreeNodeModel methodsFor: 'accessing' stamp: 'AndreiChis 7/17/2010 17:04'!
containerTree: anObject
	containerTree := anObject ! !

!SGLTreeNodeModel methodsFor: 'accessing' stamp: 'AndreiChis 7/18/2010 14:57'!
contents
	^ self childrenItems select: [ :each | each shouldBeDisplayed ] ! !

!SGLTreeNodeModel methodsFor: 'as yet unclassified' stamp: 'AndreiChis 7/17/2010 17:33'!
displayText
	^self containerTree glamourPresentation formatedDisplayValueOf: self item! !

!SGLTreeNodeModel methodsFor: 'accessing' stamp: 'AndreiChis 7/18/2010 16:35'!
expanded
	^ expanded ifNil: [ expanded := self containerTree shouldAllExpand or: [ self path size == 1 and: [self containerTree shouldRootsExpand ] ] ]! !

!SGLTreeNodeModel methodsFor: 'accessing' stamp: 'AndreiChis 7/18/2010 14:01'!
expanded: aBoolean
	expanded := aBoolean ! !

!SGLTreeNodeModel methodsFor: 'accessing' stamp: 'AndreiChis 7/20/2010 18:27'!
htmlId
	^ htmlId ! !

!SGLTreeNodeModel methodsFor: 'accessing' stamp: 'AndreiChis 7/20/2010 18:27'!
htmlId: anId
	htmlId := anId 
! !

!SGLTreeNodeModel methodsFor: 'as yet unclassified' stamp: 'AndreiChis 7/17/2010 17:02'!
item 
	^ item! !

!SGLTreeNodeModel methodsFor: 'as yet unclassified' stamp: 'AndreiChis 7/17/2010 17:02'!
item: anObject
	item := anObject ! !

!SGLTreeNodeModel methodsFor: 'accessing' stamp: 'AndreiChis 7/17/2010 17:40'!
parentNode
	^ parentNode ! !

!SGLTreeNodeModel methodsFor: 'accessing' stamp: 'AndreiChis 7/17/2010 21:32'!
parentNode: aNode
	^ parentNode:= aNode ! !

!SGLTreeNodeModel methodsFor: 'accessing' stamp: 'AndreiChis 7/17/2010 19:49'!
path
	"Build the list of nodes to the root"
	
	|aCollection|
	aCollection := OrderedCollection new.
	self parentNode ifNotNil: [
		(aCollection includes: self parentNode)
			ifFalse: [aCollection addAll: self parentNode path ] ].
	aCollection add: self.
	^ aCollection! !

!SGLTreeNodeModel methodsFor: 'as yet unclassified' stamp: 'AndreiChis 7/17/2010 22:45'!
shouldBeDisplayed
	^ self shouldBeDisplayedByTags! !

!SGLTreeNodeModel methodsFor: 'as yet unclassified' stamp: 'AndreiChis 7/18/2010 13:32'!
shouldBeDisplayedByTags
	| nodeTags |
	self containerTree tagsToFilterBy isEmpty ifTrue: [ ^ true ].
	self withContentsDo: [ :node | 
		nodeTags := self containerTree glamourPresentation tagsFor: node item to: #filter.
		(self containerTree tagsToFilterBy allSatisfy: [ :each | nodeTags includes: each ])
			ifTrue: [ ^ true ] ].
	^ false! !

!SGLTreeNodeModel methodsFor: 'as yet unclassified' stamp: 'AndreiChis 7/18/2010 13:32'!
withContentsDo: aBlock
	self flag: 'if the tree is infinite due to recursion, this might not stop'.
	aBlock value: self.
	self contents do: [:each | each withContentsDo: aBlock ]! !

!GLMBrowser methodsFor: '*Glamour-Seaside-Scripting' stamp: 'tg 12/21/2009 12:53'!
registerInSeasideOn: aModel
	SGLDefaultComponent register: self on: aModel! !
SGLAccumulator initialize!
SGLAllowNil initialize!
SGLCodeBrowser initialize!
SGLComposedTabulator initialize!
SGLComposedTabulatorWithActions initialize!
SGLDefaultComponent initialize!
SGLDifferentComposites initialize!
SGLFileBrowser initialize!
SGLFinderWithTabulator initialize!
SGLListTags initialize!
SGLLongTabulator initialize!
SGLOnePaneMultipleTabPresentations initialize!
SGLOnePaneTabulator initialize!
SGLOnePaneWithTitle initialize!
SGLPierBrowser initialize!
SGLSTPackageBrowser initialize!
SGLSimpleFinder initialize!
SGLSimpleTree initialize!
SGLTabsWithActions initialize!
SGLTreeWithExpansion initialize!
SGLTreeWithLeafTags initialize!
SGLTreeWithTags initialize!
SGLVerySimpleFinder initialize!
